/******************************************************
*                Math machine learning                *
*                                                     *
* Learns to add two integers a and b, where 1≤a;b≤5  *
*                                                     *
*          Written by M. Bindhammer 2012              *
*******************************************************/



//*****************************************************
//*********** Global variables and arrays *************
//*****************************************************

int a; //summand 1
int b; //summand 2
int c; //sum
int f_i=0; //control vairables for false operation FOR loops
int f_j=1; 
int f_k=2; 
int f_m; 
int f_n; 
int f_o;
int f_x;

int t_i=0; //control vairables for true operation FOR loops
int t_j=1; 
int t_k=2; 
int t_m; 
int t_n; 
int t_o;
int t_x;

int i; //control variables for FOR loops
int k;
int ex;

int a_2=0; //counter variables
int a_3=0;
int a_4=0;
int a_5=0;
int a_6=0;
int a_7=0;
int a_8=0;
int a_9=0;
int a_10=0;
int a_total; //sum of all counter variables

int false_operations[800]; //memory array for false operations
int true_operations[800];  //memory array for true operations

int array_1[11]={1,0,0,0,0,0,0,0,0,0,1}; //memory arrays for integers
int array_a[11]={0,0,0,0,0,0,0,0,0,0,0}; 
int array_b[11]={0,0,0,0,0,0,0,0,0,0,0};
int array_c[11]={0,0,0,0,0,0,0,0,0,0,0};
int array_d[11]={0,0,0,0,0,0,0,0,0,0,0};
int array_e[11]={0,0,0,0,0,0,0,0,0,0,0};
int array_f[11]={0,0,0,0,0,0,0,0,0,0,0};
int array_g[11]={0,0,0,0,0,0,0,0,0,0,0};
int array_h[11]={0,0,0,0,0,0,0,0,0,0,0};
int array_i[11]={0,0,0,0,0,0,0,0,0,0,0};

int sum[10]={0,0,0,0,0,0,0,0,0,0}; //array to build sum

void setup() 
{
  Serial.begin(9600);
  randomSeed(analogRead(0)); //not used now for testing purposes
}

void loop() 
{
  main:
  f_m=0; //reset control variables
  f_n=1; 
  f_o=2; 
  t_m=0; 
  t_n=1; 
  t_o=2; 
  a=1; //set summand 1 equal to 1 to speed up learning progress
  b=random(1,10); //generate a random value for summand 2
  c=random(1,11); //generate a random value for sum
  f_x=f_i/3; //calculate stopping criterion for FOR loop control variables
  t_x=t_i/3;
  
  //circumvent that a false operation will be generated which is already stored in the false operation array
  //circumvent furthermore that a pair of summands (which is already stored in the true operation array) with a false result will be generated 
  //e.g. if 1+1=2 is true, 1+1=3 can not be true
  for (int f_l=0; f_l<f_x; f_l++)
  { 
    if ((false_operations[f_m]==a&&false_operations[f_n]==b&&false_operations[f_o]==c)||(true_operations[f_m]==a&&true_operations[f_n]==b)) 
    { 
      goto main;
    }
    Serial.print("false: "); //only for testing
    Serial.print(false_operations[f_m]);
    Serial.print(", ");
    Serial.print(false_operations[f_n]);
    Serial.print(", ");
    Serial.println(false_operations[f_o]);
    f_m=f_m+3; //increment control variables to read out next address 
    f_n=f_n+3;
    f_o=f_o+3;
  }
  //circumvent that a pair of summands will be generated which is already stored in the true operation array
  for (int t_l=0; t_l<t_x; t_l++)
  { 
    if (true_operations[t_m]==a&&true_operations[t_n]==b) 
    {
      goto main;
    }
    Serial.print("true: "); //only for testing
    Serial.print(true_operations[t_m]);
    Serial.print(", ");
    Serial.print(true_operations[t_n]);
    Serial.print(", ");
    Serial.println(true_operations[t_o]);
    t_m=t_m+3; //increment control variables to read out next address 
    t_n=t_n+3;
    t_o=t_o+3;
  }
  Serial.println(" ");
  Serial.print(a); //print result      
  Serial.print(" + ");
  Serial.print(b);
  Serial.print(" = ");
  Serial.println(c);
  Serial.println(" ");
  Serial.println("send y if equation is true"); //instructions for the teacher
  Serial.println("send n if equation is false");
  Serial.println(" ");
  check_input:                                                                  
  char ser = Serial.read();
  if(ser == 'y') //routine if char 'y' was sent via serial monitor
  {
    true_operations[t_i] = a; //store as true tagged operations in according array address
    true_operations[t_j] = b;
    true_operations[t_k] = c;
    t_i=t_i+3; //increment control variables to move to next address for storage
    t_j=t_j+3;
    t_k=t_k+3;
    if(c==2)
    {
     array_a[0]=a; //store learned operation in array
     array_a[b]=b;
     array_a[10]=c;
     a_2=1;
    }
    if(c==3)
    {
     array_b[0]=a; //store learned operation in array
     array_b[b]=b;
     array_b[10]=c;
     a_3=1;
    }
    if(c==4)
    {
     array_c[0]=a; //store learned operation in array
     array_c[b]=b;
     array_c[10]=c;
     a_4=1;
    }
    if(c==5)
    {
     array_d[0]=a; //store learned operation in array
     array_d[b]=b;
     array_d[10]=c;
     a_5=1;
    }
    if(c==6)
    {
     array_e[0]=a; //store learned operation in array
     array_e[b]=b;
     array_e[10]=c;
     a_6=1;
    }
    if(c==7)
    {
     array_f[0]=a; //store learned operation in array
     array_f[b]=b;
     array_f[10]=c;
     a_7=1;
    }
    if(c==8)
    {
     array_g[0]=a; //store learned operation in array
     array_g[b]=b;
     array_g[10]=c;
     a_8=1;
    }
    if(c==9)
    {
     array_h[0]=a; //store learned operation in array
     array_h[b]=b;
     array_h[10]=c;
     a_9=1;
    }
    if(c==10)
    {
     array_i[0]=a; //store learned operation in array
     array_i[b]=b;
     array_i[10]=c;
     a_10=1;
    }
    a_total=a_2+a_3+a_4+a_5+a_6+a_7+a_8+a_9+a_10; 
    if(a_total==9)
    {
      delay(500);
      Serial.println(" ");
      Serial.println("Starting subsituation...");
      Serial.println(" ");
      print_memory(array_1); //print elements of array 
      delay(100);
      print_memory(array_a); 
      delay(100);
      print_memory(array_b);
      delay(100);
      print_memory(array_c);
      delay(100);
      print_memory(array_d);
      delay(100);
      print_memory(array_e);
      delay(100);
      print_memory(array_f);
      delay(100);
      print_memory(array_g);
      delay(100);
      print_memory(array_h);
      delay(100);
      print_memory(array_i);
      delay(100);
      
      
//*****************************************************
//******************* Substitution ********************
//*****************************************************
  
  for (i=1; i<10; i++)
  {
    if (array_a[10]==array_b[i])
    {
      for (k=1; k<i+1; k++)
      {
        array_b[k]=array_a[k-1];
      }
      break;
    }
  }
  for (i=1; i<10; i++)
  {
    if (array_b[10]==array_c[i])
    {
      for (k=1; k<i+1; k++)
      {
        array_c[k]=array_b[k-1];
      }
      break;
    }
  }
  for (i=1; i<10; i++)
  {
    if (array_c[10]==array_d[i])
    {
      for (k=1; k<i+1; k++)
      {
        array_d[k]=array_c[k-1];
      }
      break;
    }
  }
  for (i=1; i<10; i++)
  {
    if (array_d[10]==array_e[i])
    {
      for (k=1; k<i+1; k++)
      {
        array_e[k]=array_d[k-1];
      }
      break;
    }
  }
  for (i=1; i<10; i++)
  {
    if (array_e[10]==array_f[i])
    {
      for (k=1; k<i+1; k++)
      {
        array_f[k]=array_e[k-1];
      }
      break;
    }
  }
  for (i=1; i<10; i++)
  {
    if (array_f[10]==array_g[i])
    {
      for (k=1; k<i+1; k++)
      {
        array_g[k]=array_f[k-1];
      }
      break;
    }
  }
  for (i=1; i<10; i++)
  {
    if (array_g[10]==array_h[i])
    {
      for (k=1; k<i+1; k++)
      {
        array_h[k]=array_g[k-1];
      }
      break;
    }
  }
  for (i=1; i<10; i++)
  {
    if (array_h[10]==array_i[i])
    {
      for (k=1; k<i+1; k++)
      {
        array_i[k]=array_h[k-1];
      }
      break;
    }
  }
     delay(500);
     Serial.println(" ");
     print_memory(array_1); //print elements of array 
     delay(100);
     print_memory(array_a); 
     delay(100);
     print_memory(array_b);
     delay(100);
     print_memory(array_c);
     delay(100);
     print_memory(array_d);
     delay(100);
     print_memory(array_e);
     delay(100);
     print_memory(array_f);
     delay(100);
     print_memory(array_g);
     delay(100);
     print_memory(array_h);
     delay(100);
     print_memory(array_i);
     delay(100);    
     Serial.println(" ");
     delay(500);
     Serial.println("I will show you now what I have learned and calculate 5 randomly generated examples"); 
     Serial.println(" ");
     delay(500);
     for(ex=0; ex<5; ex++) //calculate 5 examples
     {
       a=random(1,6); //generate a random value for summand 1
       b=random(1,6); //generate a random value for summand 2
       Serial.print(a);
       Serial.print(" + ");
       Serial.print(b);
       Serial.println(" = ?");
       delay(500);

     
//*****************************************************
//*********************** Adder ***********************
//*****************************************************

//********* Store summand 1 in the sum array **********
if (a==array_1[10])
{
  for (i=0; i<10; i++)
  {
    if (array_1[i]!=1)
    {
    break;
    }
    else
    {
     sum[i]=array_1[i];
    }
  }
}
if (a==array_a[10])
{
  for (i=0; i<10; i++)
  {
    if (array_a[i]!=1)
    {
    break;
    }
    else
    {
     sum[i]=array_a[i];
    }
  }
}
if (a==array_b[10])
{
  for (i=0; i<10; i++)
  {
    if (array_b[i]!=1)
    {
    break;
    }
    else
    {
     sum[i]=array_b[i];
    }
  }
}
if (a==array_c[10])
{
  for (i=0; i<10; i++)
  {
    if (array_c[i]!=1)
    {
    break;
    }
    else
    {
     sum[i]=array_c[i];
    }
  }
}

if (a==array_d[10])
{
  for (i=0; i<10; i++)
  {
    if (array_d[i]!=1)
    {
    break;
    }
    else
    {
     sum[i]=array_d[i];
    }
  }
}
k=i; //determinate starting memory address for summand 2

//********* Store summand 2 in the sum array **********
if (b==array_1[10])
{
  for (i=0; i<10; i++)
  {
    if (array_1[i]!=1)
    {
    break;
    }
    else
    {
     sum[k+i]=array_1[i];
    }
  }
}
if (b==array_a[10])
{
  for (i=0; i<10; i++)
  {
    if (array_a[i]!=1)
    {
    break;
    }
    else
    {
     sum[k+i]=array_a[i];
    }
  }
}
if (b==array_b[10])
{
  for (i=0; i<10; i++)
  {
    if (array_b[i]!=1)
    {
    break;
    }
    else
    {
     sum[k+i]=array_b[i];
    }
  }
}
if (b==array_c[10])
{
  for (i=0; i<10; i++)
  {
    if (array_c[i]!=1)
    {
    break;
    }
    else
    {
     sum[k+i]=array_c[i];
    }
  }
}
if (b==array_d[10])
{
  for (i=0; i<10; i++)
  {
    if (array_d[i]!=1)
    {
    break;
    }
    else
    {
     sum[k+i]=array_d[i];
    }
  }
}
       Serial.print(a);
       Serial.print(" + ");
       Serial.print(b);
       Serial.print(" = ");
       print_sum(sum); 
       delay(500);


//*****************************************************
//********************* Comparator ********************
//*****************************************************

if(sum[0]==array_a[0]&&sum[1]==array_a[1]&&sum[2]==array_a[2]&&sum[3]==array_a[3]&&sum[4]==array_a[4]&&sum[5]==array_a[5]&&sum[6]==array_a[6]&&sum[7]==array_a[7]&&sum[8]==array_a[8]&&sum[9]==array_a[9])
{
  c=2;
}
if(sum[0]==array_b[0]&&sum[1]==array_b[1]&&sum[2]==array_b[2]&&sum[3]==array_b[3]&&sum[4]==array_b[4]&&sum[5]==array_b[5]&&sum[6]==array_b[6]&&sum[7]==array_b[7]&&sum[8]==array_b[8]&&sum[9]==array_b[9])
{
  c=3;
}
if(sum[0]==array_c[0]&&sum[1]==array_c[1]&&sum[2]==array_c[2]&&sum[3]==array_c[3]&&sum[4]==array_c[4]&&sum[5]==array_c[5]&&sum[6]==array_c[6]&&sum[7]==array_c[7]&&sum[8]==array_c[8]&&sum[9]==array_c[9])
{
  c=4;
}
if(sum[0]==array_d[0]&&sum[1]==array_d[1]&&sum[2]==array_d[2]&&sum[3]==array_d[3]&&sum[4]==array_d[4]&&sum[5]==array_d[5]&&sum[6]==array_d[6]&&sum[7]==array_d[7]&&sum[8]==array_d[8]&&sum[9]==array_d[9])
{
  c=5;
}
if(sum[0]==array_e[0]&&sum[1]==array_e[1]&&sum[2]==array_e[2]&&sum[3]==array_e[3]&&sum[4]==array_e[4]&&sum[5]==array_e[5]&&sum[6]==array_e[6]&&sum[7]==array_e[7]&&sum[8]==array_e[8]&&sum[9]==array_e[9])
{
  c=6;
}
if(sum[0]==array_f[0]&&sum[1]==array_f[1]&&sum[2]==array_f[2]&&sum[3]==array_f[3]&&sum[4]==array_f[4]&&sum[5]==array_f[5]&&sum[6]==array_f[6]&&sum[7]==array_f[7]&&sum[8]==array_f[8]&&sum[9]==array_f[9])
{
  c=7;
}
if(sum[0]==array_g[0]&&sum[1]==array_g[1]&&sum[2]==array_g[2]&&sum[3]==array_g[3]&&sum[4]==array_g[4]&&sum[5]==array_g[5]&&sum[6]==array_g[6]&&sum[7]==array_g[7]&&sum[8]==array_g[8]&&sum[9]==array_g[9])
{
  c=8;
}
if(sum[0]==array_h[0]&&sum[1]==array_h[1]&&sum[2]==array_h[2]&&sum[3]==array_h[3]&&sum[4]==array_h[4]&&sum[5]==array_h[5]&&sum[6]==array_h[6]&&sum[7]==array_h[7]&&sum[8]==array_h[8]&&sum[9]==array_h[9])
{
  c=9;
}
if(sum[0]==array_i[0]&&sum[1]==array_i[1]&&sum[2]==array_i[2]&&sum[3]==array_i[3]&&sum[4]==array_i[4]&&sum[5]==array_i[5]&&sum[6]==array_i[6]&&sum[7]==array_i[7]&&sum[8]==array_i[8]&&sum[9]==array_i[9])
{
  c=10;
}


//*****************************************************
//******************* Print results *******************
//*****************************************************

Serial.print(a);
Serial.print(" + ");
Serial.print(b);
Serial.print(" = ");
Serial.print(c);
Serial.println(" ");
Serial.println(" ");
delay(500);

sum[0]=0;
sum[1]=0;
sum[2]=0;
sum[3]=0;
sum[4]=0;
sum[5]=0;
sum[6]=0;
sum[7]=0;
sum[8]=0;
sum[9]=0;
     }
      while(1) //loop forever till reset button is pressed
      {
      }
    }
  }
  else if(ser == 'n') //routine if char 'n' was sent via serial monitor
  {
    false_operations[f_i] = a; //store as false tagged operations in according array address
    false_operations[f_j] = b;
    false_operations[f_k] = c;
    f_i=f_i+3; //increment control variables to move to next address for storage
    f_j=f_j+3;
    f_k=f_k+3;
  }
  else
  { 
  goto check_input; //goto label 'check_input' if char 'y' or 'n' was not sent
  }
}

//*****************************************************
//*************** Function declarations ***************
//*****************************************************

void print_memory(int x[11]) //print elements of arrays for testing
{
  Serial.print(x[0]);
  Serial.print(", ");
  Serial.print(x[1]);
  Serial.print(", ");
  Serial.print(x[2]);
  Serial.print(", ");
  Serial.print(x[3]);
  Serial.print(", ");
  Serial.print(x[4]);
  Serial.print(", ");
  Serial.print(x[5]);
  Serial.print(", ");
  Serial.print(x[6]);
  Serial.print(", ");
  Serial.print(x[7]);
  Serial.print(", ");
  Serial.print(x[8]);
  Serial.print(", ");
  Serial.print(x[9]);
  Serial.print(", ");
  Serial.println(x[10]);
}

void print_sum(int y[10]) //print elements of arrays for testing
{
  Serial.print(y[0]);
  Serial.print(", ");
  Serial.print(y[1]);
  Serial.print(", ");
  Serial.print(y[2]);
  Serial.print(", ");
  Serial.print(y[3]);
  Serial.print(", ");
  Serial.print(y[4]);
  Serial.print(", ");
  Serial.print(y[5]);
  Serial.print(", ");
  Serial.print(y[6]);
  Serial.print(", ");
  Serial.print(y[7]);
  Serial.print(", ");
  Serial.print(y[8]);
  Serial.print(", ");
  Serial.println(y[9]);
}
